/*

			Sky Screen Saver

*/

#include "sunclock.h"

/* Global used by SCRNSAVE.LIB. Required for all screen savers. */

char szAppName[40];

/* Globals exported. */

char szName[] = "Sky Screen Saver";

/* Externals defined in SCRNSAVE.LIB. Required for all screen savers. */

HINSTANCE hMainInstance;
HWND hMainWindow;
char szName[TITLEBARNAMELEN];
char szScreenSaver[22];
char szHelpFile[MAXFILELEN];
char szNoHelpMemory[BUFFLEN];
UINT MyHelpMessage;
HOOKPROC fpMessageFilter;

//	Main configuration parameters and their .ini file names

static char szLatDeg[] = "LatitudeDeg";
int latDeg;
static char szLatMin[] = "LatitudeMin";
int latMin;
static char szLatSec[] = "LatitudeSec";
int latSec;
static char szLonDeg[] = "LongitudeDeg";
int lonDeg;
static char szLonMin[] = "LongitudeMin";
int lonMin;
static char szLonSec[] = "LongitudeSec";
int lonSec;

//	Detailed configuration parameters and .ini file names

static char szStarMag[] = "StarLimitMag";		// skyLimitMag
static char szShowStarName[] = "StarNames";		// skyShowName
static char szStarNameMag[] = "StarNameMag";	// skyNameMag
static char szShowBflam[] = "StarBflam";		// skyShowBflam
static char szStarBflamMag[] = "StarBflamMag";	// skyBflamMag
static char szShowDeep[] = "Deepsky";			// skyShowDeep
static char szDeepskyMag[] = "DeepskyMag";		// skyDeepMag
static char szConstellOut[] = "ConstOutlines";	// skyShowConstellations
static char szConstellBounds[] = "ConstBounds";	// skyShowConbounds
static char szConstellNames[] = "ConstNames";	// skyShowConnames
static char szConstellAlign[] = "ConstNameAlign"; // skyAlignConnames 
static char szCoords[] = "Coordinates";			// skyShowCoords
static char szSolar[] = "SolarSystemObj";		// skyShowPlanets
static char szTiming[] = "Timing";				// skyShowTiming

/* RegisterDialogClasses -- Entry point for registering window
							classes required by configuration dialog box.
*/

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
    return TRUE;
}

//	DlgDetailedConf  --  Perform detailed configuration

static char *ffp(double v)
{
 	static char s[40];
	int whole = (int) v,
		frac = ((int) ((v * 10) + 0.5)) % 10;
		
	if (frac == 0) {
		wsprintf(s, "%d", whole);
	} else {
		wsprintf(s, "%d.%d", whole, frac);
	}
	return s;	
}

DialogueProc(DlgDetailedConf)
{
	char s[80];

    switch (message) {
        case WM_INITDIALOG:        
#define Fp(i, v) SetDlgItemText(hDlg, i, ffp(v))
#define Ck(i, v) CheckDlgButton(hDlg, i, v)
			Fp(DCONF_STAR_MAGLIM, skyLimitMag);
			Ck(DCONF_SHOW_NAME, skyShowName);
			Fp(DCONF_SHOW_NAME_MAG, skyNameMag);
			Ck(DCONF_SHOW_BFLAM, skyShowBflam);
			Fp(DCONF_SHOW_BFLAM_MAG, skyBflamMag);
			Ck(DCONF_SHOW_DEEPSKY, skyShowDeep);
			Fp(DCONF_SHOW_DEEPSKY_MAG, skyDeepMag);
			
			Ck(DCONF_CONST_OUTLINES, skyShowConstellations);
			Ck(DCONF_CONST_BOUNDARIES, skyShowConbounds);
			Ck(DCONF_CONST_NAMES, skyShowConnames);
			Ck(DCONF_CONST_ALIGN_NAMES, skyAlignConnames);

			Ck(DCONF_SHOW_COORDS, skyShowCoords);
			Ck(DCONF_SHOW_SOLARSYS, skyShowPlanets);

			Ck(DCONF_SHOW_TIMER, skyShowTiming);
#undef Ck			
#undef Fp
            return TRUE;

        case WM_COMMAND:
            switch (wParam) {
                case IDOK:
#define Fp(i, v) GetDlgItemText(hDlg, i, s, sizeof(s) - 1); v = atof(s)
#define Ck(i, v) v = IsDlgButtonChecked(hDlg, i)
					Fp(DCONF_STAR_MAGLIM, skyLimitMag);
					Ck(DCONF_SHOW_NAME, skyShowName);
					Fp(DCONF_SHOW_NAME_MAG, skyNameMag);
					Ck(DCONF_SHOW_BFLAM, skyShowBflam);
					Fp(DCONF_SHOW_BFLAM_MAG, skyBflamMag);
					Ck(DCONF_SHOW_DEEPSKY, skyShowDeep);
					Fp(DCONF_SHOW_DEEPSKY_MAG, skyDeepMag);
					
					Ck(DCONF_CONST_OUTLINES, skyShowConstellations);
					Ck(DCONF_CONST_BOUNDARIES, skyShowConbounds);
					Ck(DCONF_CONST_NAMES, skyShowConnames);
					Ck(DCONF_CONST_ALIGN_NAMES, skyAlignConnames);
		
					Ck(DCONF_SHOW_COORDS, skyShowCoords);
					Ck(DCONF_SHOW_SOLARSYS, skyShowPlanets);
		
					Ck(DCONF_SHOW_TIMER, skyShowTiming);
#undef Ck			
#undef Fp
                    EndDialog(hDlg, TRUE);
                    return TRUE;
                    
                case IDCANCEL:
                    EndDialog(hDlg, FALSE);
                    return TRUE;

            }
            break;
    }
    return FALSE;
}

/* ScreenSaverConfigureDialog -- Dialog box function for configuration dialog.

	Params:  hWnd -- Handle to window

	Return:  None
*/

DialogueProc(ScreenSaverConfigureDialog)
{
	static HWND hIDOK;

    switch (message) {
        case WM_INITDIALOG:
            GetIniEntries();
            GetIniSettings();

			SetDlgItemInt(hDlg, IDC_CONF_LATDEG, abs(latDeg), FALSE);
			SetDlgItemInt(hDlg, IDC_CONF_LATMIN, latMin, FALSE);
			SetDlgItemInt(hDlg, IDC_CONF_LATSEC, latSec, FALSE);
			CheckDlgButton(hDlg, IDC_CONF_LAT_NORTH, latDeg > 0);
			CheckDlgButton(hDlg, IDC_CONF_LAT_SOUTH, latDeg < 0);

			SetDlgItemInt(hDlg, IDC_CONF_LONGDEG, abs(lonDeg), FALSE);
			SetDlgItemInt(hDlg, IDC_CONF_LONGMIN, lonMin, FALSE);
			SetDlgItemInt(hDlg, IDC_CONF_LONGSEC, lonSec, FALSE);
			CheckDlgButton(hDlg, IDC_CONF_LON_WEST, lonDeg > 0);
			CheckDlgButton(hDlg, IDC_CONF_LON_EAST, lonDeg < 0);
            hIDOK = GetDlgItem(hDlg, IDOK);
            return TRUE;

        case WM_COMMAND:
            switch (wParam) {
                case IDOK:
					latDeg = GetDlgItemInt(hDlg, IDC_CONF_LATDEG, NULL, FALSE);
					latMin = GetDlgItemInt(hDlg, IDC_CONF_LATMIN, NULL, FALSE);
					latSec = GetDlgItemInt(hDlg, IDC_CONF_LATSEC, NULL, FALSE);
					if (IsDlgButtonChecked(hDlg, IDC_CONF_LAT_SOUTH)) {
						latDeg = - latDeg;
					}
                    
					lonDeg = GetDlgItemInt(hDlg, IDC_CONF_LONGDEG, NULL, FALSE);
					lonMin = GetDlgItemInt(hDlg, IDC_CONF_LONGMIN, NULL, FALSE);
					lonSec = GetDlgItemInt(hDlg, IDC_CONF_LONGSEC, NULL, FALSE);
					if (IsDlgButtonChecked(hDlg, IDC_CONF_LON_EAST)) {
						lonDeg = - lonDeg;
					}
					
					/* Write out all configuration parameters, including
					   those controlled by the detailed configuration
					   dialogue. */
                    {
						HKEY keyh;
						DWORD dispos;
						TCHAR keyname[80];
						DWORD fVal;
						
						strcpy(keyname, "Software\\Fourmilab.ch\\");
						strcat(keyname, szAppName);
						if (RegCreateKeyEx(HKEY_CURRENT_USER,
									keyname,					// Subkey name
									0,							// Reserved
									"",							// Bogus class string
									REG_OPTION_NON_VOLATILE,	// Options
									KEY_ALL_ACCESS,				// Access rights			
									NULL,						// Security attributes
									&keyh,						// Returned handle to the key
									&dispos) == ERROR_SUCCESS) { // Returned disposition
#define regStore(name, value) RegSetValueEx(keyh, name, 0, REG_DWORD, (BYTE *) &value, sizeof(value))
#define regStoreF(name, value) fVal = ((int) (((value) * 10.0) + 0.5)); regStore(name, fVal)
								regStore(szLatDeg, latDeg);  
								regStore(szLatMin, latMin);  
								regStore(szLatSec, latSec);
				                
								regStore(szLonDeg, lonDeg);  
								regStore(szLonMin, lonMin);  
								regStore(szLonSec, lonSec);
											
								if (skyLimitMag > 6.5) {
									skyLimitMag = 6.5;
								}
								                 
								regStoreF(szStarMag, skyLimitMag);
								regStore(szShowStarName, skyShowName);
								regStoreF(szStarNameMag, skyNameMag);
								regStore(szShowBflam, skyShowBflam);
								regStoreF(szStarBflamMag, skyBflamMag);
								regStore(szShowDeep, skyShowDeep);
								regStoreF(szDeepskyMag, skyDeepMag);
								
								regStore(szConstellOut, skyShowConstellations);
								regStore(szConstellBounds, skyShowConbounds);
								regStore(szConstellNames, skyShowConnames);
								regStore(szConstellAlign, skyAlignConnames);
								
								regStore(szCoords, skyShowCoords);
								regStore(szSolar, skyShowPlanets);
								
								regStore(szTiming, skyShowTiming);								
								

								RegCloseKey(keyh);
						}
                   }
#undef regStore              
#undef regStoreF
                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case IDCANCEL:
                    EndDialog(hDlg, FALSE);
                    return TRUE;

                case IDC_CONF_DODETAIL:		// Detailed configuration
	                {
	                    FARPROC fpDialog;
	
	                    if ((fpDialog = MakeProcInstance((FARPROC) DlgDetailedConf, hMainInstance)) == NULL)
	                        return FALSE;
	                    DialogBox(hMainInstance, MAKEINTRESOURCE(DLG_CONFIGURE_DETAILED),
	                              hDlg, (DLGPROC) fpDialog);
	                    FreeProcInstance(fpDialog);
	                }
                	break;

                case ID_HELP:
DoHelp:
                    MessageBox(hDlg, "Sky screen saver.", szName, MB_OK);
                    break;
            }
            break;

        default:
            if (message == MyHelpMessage)     // Context sensitive help msg.
                goto DoHelp;
    }
    return FALSE;
}

/* GetIniSettings -- Get initial settings from WIN.INI

	Params:  hWnd -- Handle to window

	Return:  None
	
	Note that initial installation defaults are set by the default
	arguments to the retrievals of the profile variables.
*/

void GetIniSettings(void)
{
	HKEY keyh;
	TCHAR keyname[80];
	DWORD fVal;
	TIME_ZONE_INFORMATION tzone;
	int longshot, lateral;
	BOOL isdst = GetTimeZoneInformation(&tzone) == TIME_ZONE_ID_DAYLIGHT;

	/* Guess initial latitude and longitude based on the
	   selected time zone.  We displace 15 degrees for every 60
	   minutes of bias from UTC in the time zone.  If the switch to
	   daylight time occurs in the first 6 months of the year, we
	   guess 45 North latitude; if in the latter half of the year
	   we guess 45 South.  If daylight time is not observed, see
	   if the time zone name begins with "SA" (as South American
	   time zones do) or contains the word "South"; if so guess
	   -45, otherwise +45). */

	longshot = (tzone.Bias * 15) / 60;
	lateral = (tzone.DaylightDate.wMonth > 0 &&
			   tzone.DaylightDate.wMonth <= 6) ? 45: -45;
			   
	if (tzone.StandardDate.wMonth == 0) {
		if ((wcsncmp(tzone.StandardName, L"SA ", 2) == 0) ||
			(wcsstr(tzone.StandardName, L"South ") != NULL)) {
			lateral = -45;
		} else {
			lateral = 45;
		}
	}  

/*{ char s[132]; wsprintf(s,
  "Longitude guess for %ls S=%d/D=%d Bias=%d Dst=%d Long=%d Lat=%d (Sbias=%d).\r\n",
  (LPSTR) tzone.StandardName, tzone.StandardDate.wMonth, tzone.DaylightDate.wMonth, 
  tzone.Bias, isdst, longshot, lateral, tzone.StandardBias); OutputDebugString(s); }*/
	
	strcpy(keyname, "Software\\Fourmilab.ch\\");
	strcat(keyname, szAppName);

	if (RegOpenKeyEx(HKEY_CURRENT_USER,
			keyname,				// Subkey name
			0,						// Reserved
			KEY_QUERY_VALUE,		// Security access mask
			&keyh) == ERROR_SUCCESS) {
		DWORD vsize;
		DWORD vtype =  REG_DWORD;

#define regGet(name, value) vsize = sizeof(value); RegQueryValueEx(keyh, name, NULL, &vtype, (BYTE *) &value, &vsize)
#define regGetF(name, value) regGet(name, fVal); value = (fVal / 10.0)

		regGet(szLatDeg, latDeg);
		regGet(szLatMin, latMin);
		regGet(szLatSec, latSec);
		
		regGet(szLonDeg, lonDeg);
		regGet(szLonMin, lonMin);
		regGet(szLonSec, lonSec);
		
		regGetF(szStarMag, skyLimitMag);
		regGet(szShowStarName, skyShowName);
		regGetF(szStarNameMag, skyNameMag);
		regGet(szShowBflam, skyShowBflam);
		regGetF(szStarBflamMag, skyBflamMag);
		regGet(szShowDeep, skyShowDeep);
		regGetF(szDeepskyMag, skyDeepMag);
		
		regGet(szSolar, skyShowPlanets);
		
		regGet(szConstellOut, skyShowConstellations);
		regGet(szConstellBounds, skyShowConbounds);
		regGet(szConstellNames, skyShowConnames);
		regGet(szConstellAlign, skyAlignConnames);
		
		regGet(szCoords, skyShowCoords);
		regGet(szTiming, skyShowTiming);
		
		RegCloseKey(keyh);
#undef regGet
#undef regGetF
	} else {
		latDeg = lateral; 
		latMin = 0; 
		latSec = 0;
		 
		lonDeg = longshot; 
		lonMin = 0; 
		lonSec = 0;
		
		skyLimitMag = 5.5; 
		skyShowName = TRUE; 
		skyNameMag = 2.0; 
		skyShowBflam = TRUE; 
		skyBflamMag = 2.5; 
		skyShowDeep = TRUE;
		skyDeepMag = 2.5; 

		skyShowPlanets = TRUE;
	    
		skyShowConstellations = TRUE;
		skyShowConbounds = TRUE;
		skyShowConnames = TRUE;
		skyAlignConnames = FALSE;

		skyShowCoords = TRUE;
	    
		skyShowTiming = FALSE;
		
	}

/*  
    latDeg = GetPrivateProfileInt(szAppName, szLatDeg, lateral, szIniFile); 
    latMin = GetPrivateProfileInt(szAppName, szLatMin, 0, szIniFile); 
    latSec = GetPrivateProfileInt(szAppName, szLatSec, 0, szIniFile); 
    lonDeg = GetPrivateProfileInt(szAppName, szLonDeg, longshot, szIniFile); 
    lonMin = GetPrivateProfileInt(szAppName, szLonMin, 0, szIniFile); 
    lonSec = GetPrivateProfileInt(szAppName, szLonSec, 0, szIniFile);
    
    skyLimitMag = GetPrivateProfileInt(szAppName, szStarMag, 55, szIniFile) / 10.0; 
    skyShowName = GetPrivateProfileInt(szAppName, szShowStarName, TRUE, szIniFile); 
    skyNameMag = GetPrivateProfileInt(szAppName, szStarNameMag, 20, szIniFile) / 10.0; 
    skyShowBflam = GetPrivateProfileInt(szAppName, szShowBflam, TRUE, szIniFile); 
    skyBflamMag = GetPrivateProfileInt(szAppName, szStarBflamMag, 25, szIniFile) / 10.0; 
    skyShowDeep = GetPrivateProfileInt(szAppName, szShowDeep, TRUE, szIniFile);
    skyDeepMag = GetPrivateProfileInt(szAppName, szDeepskyMag, 25, szIniFile) / 10.0; 

    skyShowPlanets = GetPrivateProfileInt(szAppName, szSolar, TRUE, szIniFile);
    
    skyShowConstellations = GetPrivateProfileInt(szAppName, szConstellOut, TRUE, szIniFile);
    skyShowConbounds = GetPrivateProfileInt(szAppName, szConstellBounds, TRUE, szIniFile);
    skyShowConnames = GetPrivateProfileInt(szAppName, szConstellNames, TRUE, szIniFile);
    skyAlignConnames = GetPrivateProfileInt(szAppName, szConstellAlign, FALSE, szIniFile);

    skyShowCoords = GetPrivateProfileInt(szAppName, szCoords, TRUE, szIniFile);
    
    skyShowTiming = GetPrivateProfileInt(szAppName, szTiming, FALSE, szIniFile);
*/
}

void GetIniEntries(void)
{
	// Load common strings from stringtable...
    LoadString(hMainInstance, idsAppName, szAppName, 40); 
	LoadString(hMainInstance, idsScreenSaver, szScreenSaver, 22);
	LoadString(hMainInstance, idsHelpFile, szHelpFile, MAXFILELEN);
	LoadString(hMainInstance, idsNoHelpMemory, szNoHelpMemory, BUFFLEN);
}
